=== debian/changelog ===
xnnpack (0.0~git20201221.e1ffe15-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream fix for FTBFS with gcc 11. (Closes: #997271)

 -- Adrian Bunk <bunk@debian.org>  Tue, 28 Dec 2021 20:29:08 +0200

xnnpack (0.0~git20201221.e1ffe15-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Thu, 02 Sep 2021 02:12:54 +0000

xnnpack (0.0~git20201221.e1ffe15-1) experimental; urgency=medium

  * New upstream version 0.0~git20201221.e1ffe15
    Please pin to this snapshot for PyTorch/v1.8.1
  * Remove 533.patch (merged upstream) and refresh remaining patches.
  * Add PyTorch/v1.8.1 upstream patches.

 -- Mo Zhou <lumin@debian.org>  Wed, 19 May 2021 13:02:03 +0800
