## xnnpack 0.0~git20220216.ae108ef

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+
 # Copyright (c) Facebook, Inc. and its affiliates.
 # All rights reserved.
 #
@@ -6,7 +7,7 @@
 # This source code is licensed under the BSD-style license found in the
 # LICENSE file in the root directory of this source tree.
 
-CMAKE_MINIMUM_REQUIRED(VERSION 3.5 FATAL_ERROR)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.12 FATAL_ERROR)
 
 # ---[ Project and semantic versioning.
 PROJECT(XNNPACK C CXX ASM)
@@ -15,6 +16,7 @@
 SET(XNNPACK_LIBRARY_TYPE "default" CACHE STRING "Type of library (shared, static, or default) to build")
 SET_PROPERTY(CACHE XNNPACK_LIBRARY_TYPE PROPERTY STRINGS default static shared)
 OPTION(XNNPACK_ENABLE_ASSEMBLY "Build XNNPACK with assembly micro-kernels" ON)
+OPTION(XNNPACK_ENABLE_JIT "Build XNNPACK with JIT micro-kernels" OFF)
 OPTION(XNNPACK_ENABLE_MEMOPT "Build XNNPACK with optimized memory allocation scheme" ON)
 OPTION(XNNPACK_ENABLE_SPARSE "Build XNNPACK with graph rewriting for sparse inference" ON)
 OPTION(XNNPACK_BUILD_TESTS "Build XNNPACK unit tests" ON)
@@ -23,7 +25,7 @@
 
 # --- [ Determine target processor
 SET(XNNPACK_TARGET_PROCESSOR "${CMAKE_SYSTEM_PROCESSOR}")
-IF(CMAKE_SYSTEM_NAME STREQUAL "Darwin" AND CMAKE_OSX_ARCHITECTURES MATCHES "^(x86_64|arm64)$")
+IF(CMAKE_SYSTEM_NAME STREQUAL "Darwin" AND CMAKE_OSX_ARCHITECTURES MATCHES "^(x86_64|arm64|arm64e)$")
   SET(XNNPACK_TARGET_PROCESSOR "${CMAKE_OSX_ARCHITECTURES}")
 ENDIF()
 
@@ -38,6 +40,12 @@
   ADD_DEFINITIONS(-DXNN_ENABLE_ASSEMBLY=1)
 ELSE()
   ADD_DEFINITIONS(-DXNN_ENABLE_ASSEMBLY=0)
+ENDIF()
+
+IF(XNNPACK_ENABLE_JIT)
+  ADD_DEFINITIONS(-DXNN_ENABLE_JIT=1)
+ELSE()
+  ADD_DEFINITIONS(-DXNN_ENABLE_JIT=0)
 ENDIF()
 
 IF(XNNPACK_ENABLE_MEMOPT)
@@ -76,7 +84,7 @@
   ELSE()
     MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_PROCESSOR is not defined")
   ENDIF()
-ELSEIF(NOT XNNPACK_TARGET_PROCESSOR MATCHES "^(i[3-6]86|x86|x86_64|AMD64|armv[5-8].*|aarch64|arm64)$")
+ELSEIF(NOT XNNPACK_TARGET_PROCESSOR MATCHES "^(i[3-6]86|x86|x86_64|AMD64|armv[5-8].*|aarch64|arm64.*|riscv(32|64|128))$")
   MESSAGE(FATAL_ERROR "Unrecognized XNNPACK_TARGET_PROCESSOR = ${XNNPACK_TARGET_PROCESSOR}")
 ENDIF()
 
@@ -160,7 +168,7 @@
 ENDIF()
 
 # ---[ XNNPACK library
-SET(XNNPACK_OPERATOR_SRCS
+SET(OPERATOR_SRCS
   src/operators/argmax-pooling-nhwc.c
   src/operators/average-pooling-nhwc.c
   src/operators/binary-elementwise-nd.c
@@ -174,17 +182,16 @@
   src/operators/fully-connected-nc.c
   src/operators/global-average-pooling-ncw.c
   src/operators/global-average-pooling-nwc.c
-  src/operators/leaky-relu-nc.c
+  src/operators/lut-elementwise-nc.c
   src/operators/max-pooling-nhwc.c
   src/operators/prelu-nc.c
   src/operators/resize-bilinear-nchw.c
   src/operators/resize-bilinear-nhwc.c
-  src/operators/sigmoid-nc.c
   src/operators/softmax-nc.c
   src/operators/unary-elementwise-nc.c
   src/operators/unpooling-nhwc.c)
 
-SET(XNNPACK_SUBGRAPH_SRCS
+SET(SUBGRAPH_SRCS
   src/subgraph/abs.c
   src/subgraph/add2.c
   src/subgraph/argmax-pooling-2d.c
@@ -192,6 +199,7 @@
   src/subgraph/bankers-rounding.c
   src/subgraph/ceiling.c
   src/subgraph/clamp.c
+  src/subgraph/convert.c
   src/subgraph/convolution-2d.c
   src/subgraph/deconvolution-2d.c
   src/subgraph/depth-to-space.c
@@ -220,26 +228,27 @@
   src/subgraph/subtract.c
   src/subgraph/unpooling-2d.c)
 
-SET(XNNPACK_LOGGING_SRCS
+SET(LOGGING_SRCS
+  src/datatype-strings.c
   src/operator-strings.c
   src/subgraph-strings.c)
 
-SET(XNNPACK_COLD_SRCS ${XNNPACK_OPERATOR_SRCS} ${XNNPACK_SUBGRAPH_SRCS} ${XNNPACK_LOGGING_SRCS})
-LIST(APPEND XNNPACK_COLD_SRCS
+SET(COLD_SRCS ${OPERATOR_SRCS} ${SUBGRAPH_SRCS} ${LOGGING_SRCS})
+LIST(APPEND COLD_SRCS
+  src/allocator.c
   src/init.c
   src/memory-planner.c
-  src/memory.c
   src/operator-delete.c
   src/runtime.c
   src/subgraph.c
   src/tensor.c)
 
-SET(XNNPACK_HOT_SRCS
+SET(HOT_SRCS
   src/indirection.c
   src/operator-run.c
   src/packing.c)
 
-SET(XNNPACK_TABLE_SRCS
+SET(TABLE_SRCS
   src/tables/exp2-k-over-64.c
   src/tables/exp2-k-over-2048.c
   src/tables/exp2minus-k-over-4.c
@@ -248,43 +257,44 @@
   src/tables/exp2minus-k-over-64.c
   src/tables/exp2minus-k-over-2048.c)
 
-SET(XNNPACK_SCALAR_MICROKERNEL_SRCS
-  src/f32-argmaxpool/4x-scalar-c1.c
-  src/f32-argmaxpool/9p8x-scalar-c1.c
-  src/f32-argmaxpool/9x-scalar-c1.c
-  src/f32-avgpool/9p8x-minmax-scalar-c1.c
-  src/f32-avgpool/9x-minmax-scalar-c1.c
-  src/f32-clamp/gen/scalar-x1.c
-  src/f32-clamp/gen/scalar-x2.c
-  src/f32-clamp/gen/scalar-x4.c
-  src/f32-conv-hwc/3x3s2p0p1c3x4-scalar-1x1.c
-  src/f32-conv-hwc/3x3s2p1c3x4-scalar-1x1.c
-  src/f32-conv-hwc2chw/3x3s2p1c3x4-scalar-1x1.c
-  src/f32-dwconv/gen/up1x4-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up1x4-minmax-scalar.c
-  src/f32-dwconv/gen/up1x4-scalar-acc2.c
-  src/f32-dwconv/gen/up1x4-scalar.c
-  src/f32-dwconv/gen/up1x9-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up1x9-minmax-scalar.c
-  src/f32-dwconv/gen/up1x9-scalar-acc2.c
-  src/f32-dwconv/gen/up1x9-scalar.c
-  src/f32-dwconv/gen/up1x25-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up1x25-minmax-scalar.c
-  src/f32-dwconv/gen/up1x25-scalar-acc2.c
-  src/f32-dwconv/gen/up1x25-scalar.c
-  src/f32-dwconv/gen/up2x4-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up2x4-minmax-scalar.c
-  src/f32-dwconv/gen/up2x4-scalar-acc2.c
-  src/f32-dwconv/gen/up2x4-scalar.c
-  src/f32-dwconv/gen/up2x9-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up2x9-minmax-scalar.c
-  src/f32-dwconv/gen/up2x9-scalar-acc2.c
-  src/f32-dwconv/gen/up2x9-scalar.c
-  src/f32-dwconv/gen/up2x25-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up2x25-minmax-scalar.c
-  src/f32-dwconv/gen/up2x25-scalar-acc2.c
-  src/f32-dwconv/gen/up2x25-scalar.c
-  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1-acc2.c
-  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1-acc3.c
-  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1-acc4.c
-  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1.c
+SET(JIT_SRCS
+  src/jit/aarch32-assembler.cc
+  src/jit/aarch64-assembler.cc
+  src/jit/assembler.cc
+  src/jit/memory.c)
+
+SET(JIT_AARCH32_SRCS
+  src/f32-gemm/4x8-aarch32-neon-cortex-a7.cc
+  src/f32-gemm/4x8-aarch32-neon-cortex-a53.cc
+  src/f32-gemm/4x8-aarch32-neon-cortex-a55.cc
+  src/f32-gemm/4x8-aarch32-neon-cortex-a75.cc
+  src/f32-gemm/4x8-aarch32-neon-ld64.cc
+  src/f32-igemm/4x8-aarch32-neon-cortex-a7.cc
+  src/f32-igemm/4x8-aarch32-neon-cortex-a53.cc
+  src/f32-igemm/4x8-aarch32-neon-cortex-a55.cc
+  src/f32-igemm/4x8-aarch32-neon-cortex-a75.cc
+  src/f32-igemm/4x8-aarch32-neon-ld64.cc
+  src/qc8-gemm/4x8-fp32-aarch32-neonv8-mlal-lane-ld64.cc
+  src/qc8-gemm/4x8c4-fp32-aarch32-neondot-ld64.cc
+  src/qc8-igemm/4x8-fp32-aarch32-neonv8-mlal-lane-ld64.cc
+  src/qc8-igemm/4x8c4-fp32-aarch32-neondot-ld64.cc
+  src/qs8-gemm/4x8-rndnu-aarch32-neon-mlal-lane-ld64.cc
+  src/qs8-gemm/4x8c4-rndnu-aarch32-neondot-ld64.cc
+  src/qs8-igemm/4x8-rndnu-aarch32-neon-mlal-lane-ld64.cc
+  src/qs8-igemm/4x8c4-rndnu-aarch32-neondot-ld64.cc)
+
+SET(JIT_AARCH64_SRCS
+  src/f32-gemm/1x8-aarch64-neonfma-cortex-a75.cc
+  src/f32-gemm/6x8-aarch64-neonfma-cortex-a75.cc
+  src/f32-igemm/1x8-aarch64-neonfma-cortex-a75.cc
+  src/f32-igemm/6x8-aarch64-neonfma-cortex-a75.cc)
+
+SET(PROD_SCALAR_PORTABLE_MICROKERNEL_SRCS
+  src/params-init.c
+  src/u8-lut32norm/scalar.c
+  src/xx-copy/memcpy.c
+  src/x8-lut/gen/lut-scalar-x4.c
+  src/x32-depthtospace2d-chw2hwc/scalar.c)
+
+SET(PROD_SCALAR_AARCH32_MICROKERNEL_SRCS
+  src/f16-f32-vcvt/gen/vcvt-scalar-x4.c
