=== debian/changelog ===
xnnpack (0.0~git20220216.ae108ef-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sat, 25 Jun 2022 20:11:28 -0700

xnnpack (0.0~git20220216.ae108ef-1) experimental; urgency=medium

  * New upstream version 0.0~git20220216.ae108ef
    Please pin to this snapshot for PyTorch/v1.12.0~rc1
  * Remove already merged patches.
  * Rebase soversion.patch
  * Resolve superfluous-file-pattern in d/copyright
  * Put binary packages to correct Sections.
  * Add changelog entry for the 0.0~git20201221.e1ffe15-2.1 NMU.
    Many thanks to Adrian Bunk!
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Sun, 22 May 2022 17:56:02 -0400
