=== debian/control ===
--- 
+++ 
@@ -20,6 +20,7 @@
                ninja-build
 
 Package: libxnnpack-dev
+Section: libdevel
 Architecture: any
 Depends: libxnnpack0 (= ${binary:Version}), ${misc:Depends}
 Description: High-efficiency floating-point neural network inference operators (dev)
@@ -33,6 +34,7 @@
  This package contains the development files.
 
 Package: libxnnpack0
+Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: High-efficiency floating-point neural network inference operators (libs)
