## xnnpack 0.0~git20221221.51a9875

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-
 # Copyright (c) Facebook, Inc. and its affiliates.
 # All rights reserved.
 #
@@ -7,10 +6,19 @@
 # This source code is licensed under the BSD-style license found in the
 # LICENSE file in the root directory of this source tree.
 
-CMAKE_MINIMUM_REQUIRED(VERSION 3.12 FATAL_ERROR)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.15 FATAL_ERROR)
+
+# MSVC runtime library flags are selected by an abstraction.
+CMAKE_POLICY(SET CMP0091 NEW)
 
 # ---[ Project and semantic versioning.
 PROJECT(XNNPACK C CXX ASM)
+
+SET(CMAKE_C_STANDARD 99)
+SET(CMAKE_C_EXTENSIONS NO)
+SET(CMAKE_CXX_STANDARD 11)
+SET(CMAKE_CXX_STANDARD_REQUIRED YES)
+SET(CMAKE_CXX_EXTENSIONS NO)
 
 # ---[ Options.
 SET(XNNPACK_LIBRARY_TYPE "default" CACHE STRING "Type of library (shared, static, or default) to build")
@@ -19,15 +27,54 @@
 OPTION(XNNPACK_ENABLE_JIT "Build XNNPACK with JIT micro-kernels" OFF)
 OPTION(XNNPACK_ENABLE_MEMOPT "Build XNNPACK with optimized memory allocation scheme" ON)
 OPTION(XNNPACK_ENABLE_SPARSE "Build XNNPACK with graph rewriting for sparse inference" ON)
+OPTION(XNNPACK_ENABLE_GEMM_M_SPECIALIZATION "Build XNNPACK with support for selecting microkernel with different MR" ON)
+OPTION(XNNPACK_BUILD_LIBRARY "Build XNNPACK library" ON)
 OPTION(XNNPACK_BUILD_TESTS "Build XNNPACK unit tests" ON)
 OPTION(XNNPACK_BUILD_BENCHMARKS "Build XNNPACK benchmarks" ON)
 OPTION(XNNPACK_USE_SYSTEM_LIBS "Use system-provided dependency libraries" OFF)
 
 # --- [ Determine target processor
-SET(XNNPACK_TARGET_PROCESSOR "${CMAKE_SYSTEM_PROCESSOR}")
-IF(CMAKE_SYSTEM_NAME STREQUAL "Darwin" AND CMAKE_OSX_ARCHITECTURES MATCHES "^(x86_64|arm64|arm64e)$")
+IF(CMAKE_OSX_ARCHITECTURES)
+  LIST(LENGTH CMAKE_OSX_ARCHITECTURES CMAKE_OSX_ARCHITECTURES_COUNT)
+  IF(CMAKE_OSX_ARCHITECTURES_COUNT GREATER 1)
+    MESSAGE(FATAL_ERROR "Unsupported XNNPACK build with multiple OSX architectures (${CMAKE_OSX_ARCHITECTURES}). "
+      "Specify a single architecture in CMAKE_OSX_ARCHITECTURES and re-configure. ")
+  ENDIF()
+  IF(NOT CMAKE_OSX_ARCHITECTURES MATCHES "^(x86_64|arm64|arm64e|arm64_32)$")
+    MESSAGE(FATAL_ERROR "Unrecognized CMAKE_OSX_ARCHITECTURES value \"${CMAKE_OSX_ARCHITECTURES}\"")
+  ENDIF()
   SET(XNNPACK_TARGET_PROCESSOR "${CMAKE_OSX_ARCHITECTURES}")
-ENDIF()
+ELSEIF(CMAKE_GENERATOR MATCHES "^Visual Studio " AND CMAKE_GENERATOR_PLATFORM)
+  IF(CMAKE_GENERATOR_PLATFORM STREQUAL "Win32")
+    SET(XNNPACK_TARGET_PROCESSOR "x86")
+  ELSEIF(CMAKE_GENERATOR_PLATFORM STREQUAL "x64")
+    SET(XNNPACK_TARGET_PROCESSOR "x86_64")
+  ELSEIF(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64")
+    SET(XNNPACK_TARGET_PROCESSOR "arm64")
+  ELSEIF(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64EC")
+    SET(XNNPACK_TARGET_PROCESSOR "arm64ec")
+  ELSE()
+    MESSAGE(FATAL_ERROR "Unsupported Visual Studio architecture \"${CMAKE_GENERATOR_PLATFORM}\"")
+  ENDIF()
+ELSEIF(CMAKE_SYSTEM_PROCESSOR MATCHES "^i[3-7]86$")
+  SET(XNNPACK_TARGET_PROCESSOR "x86")
+ELSEIF(CMAKE_SYSTEM_PROCESSOR STREQUAL "AMD64")
+  SET(XNNPACK_TARGET_PROCESSOR "x86_64")
+ELSEIF(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv[5-8]")
+  SET(XNNPACK_TARGET_PROCESSOR "arm")
+ELSEIF(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
+  SET(XNNPACK_TARGET_PROCESSOR "arm64")
+ELSEIF(NOT XNNPACK_TARGET_PROCESSOR MATCHES "^(x86(_64)?|arm64|riscv(32|64|128)|Hexagon)$")
+  SET(XNNPACK_TARGET_PROCESSOR "${CMAKE_SYSTEM_PROCESSOR}")
+ELSE()
+  MESSAGE(FATAL_ERROR "Unrecognized CMAKE_SYSTEM_PROCESSOR value \"${CMAKE_SYSTEM_PROCESSOR}\"")
+ENDIF()
+
+# --- [ Processor-specific options
+OPTION(XNNPACK_ENABLE_ARM_FP16_SCALAR "Build XNNPACK with ARM FP16 (FP16 data processing) scalar micro-kernels" ON)
+OPTION(XNNPACK_ENABLE_ARM_FP16_VECTOR "Build XNNPACK with ARM FP16 (FP16 data processing) vector micro-kernels" ON)
+OPTION(XNNPACK_ENABLE_ARM_BF16 "Build XNNPACK with ARM BF16 (BFLOAT16) micro-kernels" ON)
+OPTION(XNNPACK_ENABLE_ARM_DOTPROD "Build XNNPACK with ARM DotProd (integer dot product) micro-kernels" ON)
 
 # ---[ CMake options
 INCLUDE(GNUInstallDirs)
@@ -36,33 +83,22 @@
   ENABLE_TESTING()
 ENDIF()
 
-IF(XNNPACK_ENABLE_ASSEMBLY)
-  ADD_DEFINITIONS(-DXNN_ENABLE_ASSEMBLY=1)
-ELSE()
-  ADD_DEFINITIONS(-DXNN_ENABLE_ASSEMBLY=0)
-ENDIF()
-
-IF(XNNPACK_ENABLE_JIT)
-  ADD_DEFINITIONS(-DXNN_ENABLE_JIT=1)
-ELSE()
-  ADD_DEFINITIONS(-DXNN_ENABLE_JIT=0)
-ENDIF()
-
-IF(XNNPACK_ENABLE_MEMOPT)
-  ADD_DEFINITIONS(-DXNN_ENABLE_MEMOPT=1)
-ELSE()
-  ADD_DEFINITIONS(-DXNN_ENABLE_MEMOPT=0)
-ENDIF()
-
-IF(XNNPACK_ENABLE_SPARSE)
-  ADD_DEFINITIONS(-DXNN_ENABLE_SPARSE=1)
-ELSE()
-  ADD_DEFINITIONS(-DXNN_ENABLE_SPARSE=0)
-ENDIF()
+ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_FP16_VECTOR=$<BOOL:${XNNPACK_ENABLE_ARM_FP16_VECTOR}>")
+ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_FP16_SCALAR=$<BOOL:${XNNPACK_ENABLE_ARM_FP16_SCALAR}>")
+ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_BF16=$<BOOL:${XNNPACK_ENABLE_ARM_BF16}>")
+ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_DOTPROD=$<BOOL:${XNNPACK_ENABLE_ARM_DOTPROD}>")
+ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ASSEMBLY=$<BOOL:${XNNPACK_ENABLE_ASSEMBLY}>")
+ADD_COMPILE_DEFINITIONS("XNN_ENABLE_JIT=$<BOOL:${XNNPACK_ENABLE_JIT}>")
+ADD_COMPILE_DEFINITIONS("XNN_ENABLE_MEMOPT=$<BOOL:${XNNPACK_ENABLE_MEMOPT}>")
+ADD_COMPILE_DEFINITIONS("XNN_ENABLE_SPARSE=$<BOOL:${XNNPACK_ENABLE_SPARSE}>")
+ADD_COMPILE_DEFINITIONS("XNN_ENABLE_GEMM_M_SPECIALIZATION=$<BOOL:${XNNPACK_ENABLE_GEMM_M_SPECIALIZATION}>")
 
 IF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
   # Disable "unary minus operator applied to unsigned type, result still unsigned" warning
   ADD_COMPILE_OPTIONS("/wd4146")
+  # Test files have many sections, increase the limit. See
+  # https://learn.microsoft.com/en-us/cpp/build/reference/bigobj-increase-number-of-sections-in-dot-obj-file.
+  ADD_COMPILE_OPTIONS("/bigobj")
 ENDIF()
 
 IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
@@ -71,27 +107,14 @@
 ENDIF()
 
 # ---[ Build flags
-IF(NOT CMAKE_SYSTEM_PROCESSOR)
-  IF(IOS)
-    LIST(LENGTH IOS_ARCH IOS_ARCH_COUNT)
-    IF(IOS_ARCH_COUNT GREATER 1)
-      MESSAGE(FATAL_ERROR "Unsupported XNNPACK build with multiple iOS architectures (${IOS_ARCH}). "
-        "Specify a single architecture in IOS_ARCH and re-configure. ")
-    ENDIF()
-    IF(NOT IOS_ARCH MATCHES "^(i386|x86_64|AMD64|armv7.*|arm64.*)$")
-      MESSAGE(FATAL_ERROR "Unrecognized IOS_ARCH = ${IOS_ARCH}")
-    ENDIF()
-  ELSE()
-    MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_PROCESSOR is not defined")
-  ENDIF()
-ELSEIF(NOT XNNPACK_TARGET_PROCESSOR MATCHES "^(i[3-6]86|x86|x86_64|AMD64|armv[5-8].*|aarch64|arm64.*|riscv(32|64|128))$")
-  MESSAGE(FATAL_ERROR "Unrecognized XNNPACK_TARGET_PROCESSOR = ${XNNPACK_TARGET_PROCESSOR}")
-ENDIF()
-
 IF(NOT CMAKE_SYSTEM_NAME)
   MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_NAME not defined")
-ELSEIF(NOT CMAKE_SYSTEM_NAME MATCHES "^(Darwin|Linux|Android|Windows|CYGWIN|MSYS)$")
-  MESSAGE(FATAL_ERROR "Unrecognized CMAKE_SYSTEM_NAME = ${CMAKE_SYSTEM_NAME}")
+ELSEIF(NOT CMAKE_SYSTEM_NAME MATCHES "^(Android|Darwin|iOS|Linux|Windows|CYGWIN|MSYS|QURT)$")
+  MESSAGE(FATAL_ERROR "Unrecognized CMAKE_SYSTEM_NAME value \"${CMAKE_SYSTEM_NAME}\"")
+ENDIF()
+IF(CMAKE_SYSTEM_NAME MATCHES "Windows")
+  # Disable min/max macros as they break std::min/max and std::numeric_limits<T>min/max.
+  ADD_COMPILE_DEFINITIONS("NOMINMAX")
 ENDIF()
 
 # ---[ Download deps
@@ -168,7 +191,10 @@
 ENDIF()
 
 # ---[ XNNPACK library
+INCLUDE(cmake/microkernels.cmake)
+
 SET(OPERATOR_SRCS
+  src/operator-delete.c
   src/operators/argmax-pooling-nhwc.c
   src/operators/average-pooling-nhwc.c
   src/operators/binary-elementwise-nd.c
@@ -177,8 +203,6 @@
   src/operators/convolution-nchw.c
   src/operators/convolution-nhwc.c
   src/operators/deconvolution-nhwc.c
-  src/operators/depth-to-space-nchw2nhwc.c
-  src/operators/depth-to-space-nhwc.c
   src/operators/fully-connected-nc.c
   src/operators/global-average-pooling-ncw.c
   src/operators/global-average-pooling-nwc.c
@@ -187,11 +211,16 @@
   src/operators/prelu-nc.c
   src/operators/resize-bilinear-nchw.c
   src/operators/resize-bilinear-nhwc.c
+  src/operators/slice-nd.c
   src/operators/softmax-nc.c
+  src/operators/transpose-nd.c
   src/operators/unary-elementwise-nc.c
   src/operators/unpooling-nhwc.c)
 
 SET(SUBGRAPH_SRCS
+  src/memory-planner.c
+  src/runtime.c
+  src/subgraph.c
   src/subgraph/abs.c
   src/subgraph/add2.c
   src/subgraph/argmax-pooling-2d.c
@@ -199,102 +228,22 @@
   src/subgraph/bankers-rounding.c
   src/subgraph/ceiling.c
   src/subgraph/clamp.c
+  src/subgraph/concatenate.c
   src/subgraph/convert.c
   src/subgraph/convolution-2d.c
+  src/subgraph/copy.c
   src/subgraph/deconvolution-2d.c
   src/subgraph/depth-to-space.c
   src/subgraph/depthwise-convolution-2d.c
   src/subgraph/divide.c
   src/subgraph/elu.c
+  src/subgraph/even-split.c
   src/subgraph/floor.c
   src/subgraph/fully-connected.c
-  src/subgraph/global-average-pooling-2d.c
+  src/subgraph/global-average-pooling.c
   src/subgraph/hardswish.c
   src/subgraph/leaky-relu.c
   src/subgraph/max-pooling-2d.c
   src/subgraph/maximum2.c
   src/subgraph/minimum2.c
   src/subgraph/multiply2.c
-  src/subgraph/negate.c
-  src/subgraph/prelu.c
-  src/subgraph/sigmoid.c
-  src/subgraph/softmax.c
-  src/subgraph/square-root.c
-  src/subgraph/square.c
-  src/subgraph/squared-difference.c
-  src/subgraph/static-constant-pad.c
-  src/subgraph/static-reshape.c
-  src/subgraph/static-resize-bilinear-2d.c
-  src/subgraph/subtract.c
-  src/subgraph/unpooling-2d.c)
-
-SET(LOGGING_SRCS
-  src/datatype-strings.c
-  src/operator-strings.c
-  src/subgraph-strings.c)
-
-SET(COLD_SRCS ${OPERATOR_SRCS} ${SUBGRAPH_SRCS} ${LOGGING_SRCS})
-LIST(APPEND COLD_SRCS
-  src/allocator.c
-  src/init.c
-  src/memory-planner.c
-  src/operator-delete.c
-  src/runtime.c
-  src/subgraph.c
-  src/tensor.c)
-
-SET(HOT_SRCS
-  src/indirection.c
-  src/operator-run.c
-  src/packing.c)
-
-SET(TABLE_SRCS
-  src/tables/exp2-k-over-64.c
-  src/tables/exp2-k-over-2048.c
-  src/tables/exp2minus-k-over-4.c
-  src/tables/exp2minus-k-over-8.c
-  src/tables/exp2minus-k-over-16.c
-  src/tables/exp2minus-k-over-64.c
-  src/tables/exp2minus-k-over-2048.c)
-
-SET(JIT_SRCS
-  src/jit/aarch32-assembler.cc
-  src/jit/aarch64-assembler.cc
-  src/jit/assembler.cc
-  src/jit/memory.c)
-
-SET(JIT_AARCH32_SRCS
-  src/f32-gemm/4x8-aarch32-neon-cortex-a7.cc
-  src/f32-gemm/4x8-aarch32-neon-cortex-a53.cc
-  src/f32-gemm/4x8-aarch32-neon-cortex-a55.cc
-  src/f32-gemm/4x8-aarch32-neon-cortex-a75.cc
-  src/f32-gemm/4x8-aarch32-neon-ld64.cc
-  src/f32-igemm/4x8-aarch32-neon-cortex-a7.cc
-  src/f32-igemm/4x8-aarch32-neon-cortex-a53.cc
-  src/f32-igemm/4x8-aarch32-neon-cortex-a55.cc
-  src/f32-igemm/4x8-aarch32-neon-cortex-a75.cc
-  src/f32-igemm/4x8-aarch32-neon-ld64.cc
-  src/qc8-gemm/4x8-fp32-aarch32-neonv8-mlal-lane-ld64.cc
-  src/qc8-gemm/4x8c4-fp32-aarch32-neondot-ld64.cc
-  src/qc8-igemm/4x8-fp32-aarch32-neonv8-mlal-lane-ld64.cc
-  src/qc8-igemm/4x8c4-fp32-aarch32-neondot-ld64.cc
-  src/qs8-gemm/4x8-rndnu-aarch32-neon-mlal-lane-ld64.cc
-  src/qs8-gemm/4x8c4-rndnu-aarch32-neondot-ld64.cc
-  src/qs8-igemm/4x8-rndnu-aarch32-neon-mlal-lane-ld64.cc
-  src/qs8-igemm/4x8c4-rndnu-aarch32-neondot-ld64.cc)
-
-SET(JIT_AARCH64_SRCS
-  src/f32-gemm/1x8-aarch64-neonfma-cortex-a75.cc
-  src/f32-gemm/6x8-aarch64-neonfma-cortex-a75.cc
-  src/f32-igemm/1x8-aarch64-neonfma-cortex-a75.cc
-  src/f32-igemm/6x8-aarch64-neonfma-cortex-a75.cc)
-
-SET(PROD_SCALAR_PORTABLE_MICROKERNEL_SRCS
-  src/params-init.c
-  src/u8-lut32norm/scalar.c
-  src/xx-copy/memcpy.c
-  src/x8-lut/gen/lut-scalar-x4.c
-  src/x32-depthtospace2d-chw2hwc/scalar.c)
-
-SET(PROD_SCALAR_AARCH32_MICROKERNEL_SRCS
-  src/f16-f32-vcvt/gen/vcvt-scalar-x4.c
