=== debian/changelog ===
xnnpack (0.0~git20221221.51a9875-1build1) mantic; urgency=medium

  * Rebuild against new pytorch.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 11 Sep 2023 21:37:39 +0200

xnnpack (0.0~git20221221.51a9875-1) unstable; urgency=medium

  * New upstream version 0.0~git20221221.51a9875
    + Please pin to this snapshot for the PyTorch/v2.0.X release.
  * Rebase existing patches.
  * rules: Specify -fPIC and shared library build to prevent link failure.

 -- Mo Zhou <lumin@debian.org>  Fri, 18 Aug 2023 18:22:47 -0400
