=== debian/rules ===
--- 
+++ 
@@ -1,11 +1,13 @@
 #!/usr/bin/make -f
 export DEB_BUILD_MAINT_OPTIONS = hardening+=all
+export DEB_CFLAGS_MAINT_APPEND = -fPIC
+export DEB_CXXFLAGS_MAINT_APPEND = -fPIC
 %:
 	dh $@ -Scmake+ninja
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DBUILD_SHARED_LIBS=ON \
+        -DXNNPACK_LIBRARY_TYPE=shared \
 		-DXNNPACK_USE_SYSTEM_LIBS=ON \
 		-DXNNPACK_BUILD_TESTS=OFF \
 		-DXNNPACK_BUILD_BENCHMARKS=OFF \
